unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SctVar, SctCtrl, AceRtfC, SctRep, ExtCtrls, StdCtrls, Buttons, SctBtn,
  AcePage, Db, DBTables;

type
  TForm1 = class(TForm)
    SctReport1: TSctReport;
    ReportPage: TSctGrouppage;
    ReportHeaderBand: TSctBand;
    ReportHeaderBandlevel: TSctLevel;
    PageHeaderBand: TSctBand;
    PageHeaderBandlevel: TSctLevel;
    DetailBand: TSctBand;
    DetailBandlevel: TSctLevel;
    PageFooterBand: TSctBand;
    PageFooterBandlevel: TSctLevel;
    ReportFooterBand: TSctBand;
    ReportFooterBandlevel: TSctLevel;
    svarDateTime: TSctDateTimeVar;
    svarPage: TSctPageVar;
    OverlayBand: TSctOverlayBand;
    OverlayBandLevel: TSctLevel;
    LbRtf: TSctRichTextLabel;
    ExprVar: TSctExprVar;
    SctReportButton1: TSctReportButton;
    DataSource1: TDataSource;
    Table1: TTable;
    DataSourceGuide: TSctDataSourceGuide;
    table1CustNoVar: TSctDBVar;
    table1CompanyVar: TSctDBVar;
    table1Addr1Var: TSctDBVar;
    table1Addr2Var: TSctDBVar;
    table1CityVar: TSctDBVar;
    table1StateVar: TSctDBVar;
    table1ZipVar: TSctDBVar;
    table1CountryVar: TSctDBVar;
    table1PhoneVar: TSctDBVar;
    table1FAXVar: TSctDBVar;
    table1TaxRateVar: TSctDBVar;
    table1ContactVar: TSctDBVar;
    table1LastInvoiceDateVar: TSctDBVar;
    varlabel: TSctvarlabel;
    varlabel1: TSctvarlabel;
    varlabel2: TSctvarlabel;
    varlabel3: TSctvarlabel;
    varlabel4: TSctvarlabel;
    varlabel5: TSctvarlabel;
    varlabel6: TSctvarlabel;
    varlabel7: TSctvarlabel;
    procedure ReportPageAfterDataSkip(Page: TSctGrouppage);
    procedure SctReportButton1BeforeRun(PageSetup: TObject);
  private
    { Private declarations }
    MyFlag: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ReportPageAfterDataSkip(Page: TSctGrouppage);
var
  s: TMemoryStream;
  H: integer;
begin
  if MyFlag then
  begin
    MyFlag := False; // Use flag to execute this only once

    //Load RTF memo into ACE variable
    s := TMemoryStream.Create;
    s.LoadFromFile('test.rtf');
    s.Position := 0;
    s.SaveToStream(ExprVar.AsStream);
    s.Free;

    // Calculate the stretched memo height
    LbRtf.StartPrint;
    H := LbRtf.SpendHeight(Page,2000);
    LbRtf.EndPrint := True;

    // We desire a true bottom margin of 1/2 inch.  We will increase it
    // by the size of the stretched RTF memo
    Page.PageSetup.BottomMargin := 0.5 + H/Page.PixelsPerInch;

    // Calculate where the Overlay band should start printing
    OverLayBand.TopOffset := Trunc( Page.PixelsPerInch *
              ( Page.PageSetup.Height
              - Page.PageSetup.TopMargin
              - Page.PageSetup.BottomMargin));

    // Set the height of the overlay band to match the memo
    OverlayBand.Height := H;
  end;
end;

procedure TForm1.SctReportButton1BeforeRun(PageSetup: TObject);
begin
  MyFlag := True; //Set a flag for one-time code
end;

end.
